//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// Pcx.cpp: implementation of the CPcx class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Pcx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPcx::CPcx()
{

}

CPcx::~CPcx()
{

}


CBitmap * CPcx::ReadPCX(CDC *dc, CString filename, CRect *rect)
{
	PCX_HEADER m_header;

	CFile    file;
	CSize    size;
	CBitmap *bmp, *p_cdc;
	CDC      cdc;
	// buffery jednotlyvych barev
	BYTE     buf[3][3000]; 
	BYTE  *cr; // pointery red green blue
	BYTE  *cg; 
	BYTE  *cb; 

	BYTE     cnt; // pocet zopakovani
	BYTE     b;   // cteny byte

	int x,y,i;
	int plane;

	if(!file.Open(filename, CFile::modeRead | CFile::typeBinary, NULL)) return NULL;
	// cteni hlavicky
	file.Read(&m_header, sizeof(m_header));

	if ( m_header.Id != 10 || m_header.Version != 5 || 
		m_header.ColorPlanes != 3 || m_header.BitsPerPixel != 8) {
		file.Close();  // nepodporovany format z moji strany - pouze 24.bit 
		return NULL;
	}
	
	// vypocet velikosti obrazku
	size.cx = m_header.Right - m_header.Left;
	size.cy = m_header.Bottom - m_header.Top;

	// tvorba bitmap
	bmp = new CBitmap;
	bmp->CreateCompatibleBitmap(dc, size.cx, size.cy);
	cdc.CreateCompatibleDC(dc);
	p_cdc = cdc.SelectObject(bmp);

	// vlastni cteni
	for(y = 0; y < size.cy; y++) {
		for( plane = 0; plane < 3; plane++)  { // precteni vsech tri barevnych hladin
			x = 0;
			while (x < m_header.BytesPerLine) {  // dekodovani jedne radky ze souboru
				file.Read(&b, sizeof(b));

		     if ((b & 0xC0) == 0xC0) {             /* Two-byte code    */
		        cnt = b & 0x3F;             /* Get run count    */
					file.Read(&b, sizeof(b));
		      }
		      else cnt = 1;                       /* Run count is one */

				for ( i = 0; i < cnt; i++ ) buf[plane][x++] = b;
			}
		}

		cr = buf[0]; // vlastni zapsani
		cg = buf[1];
		cb = buf[2];
		for(x = 0; x < m_header.BytesPerLine; x++) 
			cdc.SetPixelV(x,y,RGB(*cr++,*cg++,*cb++));
	}

	file.Close();

	cdc.SelectObject(p_cdc);

	rect->left = 0;
	rect->SetRect(0, 0, size.cx, size.cy);

	return bmp;
}

BYTE* CPcx::LoadPCX(CString filename, int *w, int *h)
{
	PCX_HEADER m_header;
   BYTE			*dataBuf;

	CFile    file;

	// buffery jednotlyvych barev
	BYTE   cnt; // pocet zopakovani
	BYTE   b;   // cteny byte

	BYTE   buf[3][1000]; 
	BYTE  *cr; // pointery red green blue
	BYTE  *cg; 
	BYTE  *cb; 

	int x, y, i, xx;
	int plane;

	if(!file.Open(filename, CFile::modeRead | CFile::typeBinary, NULL)) return NULL;
	// cteni hlavicky
	file.Read(&m_header, sizeof(m_header));

	if ( m_header.Id != 10 || m_header.Version != 5 || 
		m_header.ColorPlanes != 3 || m_header.BitsPerPixel != 8) {
		file.Close();  // nepodporovany format z moji strany - pouze 24.bit 
		return NULL;
	}
	
	// vypocet velikosti obrazku
	*w = m_header.Right - m_header.Left;
	*h = m_header.Bottom - m_header.Top;

	// tvorba bitmap
	dataBuf = new BYTE[(*w+1) * (*h+2) * 3];
	ZeroMemory(dataBuf, sizeof(BYTE)*3*(*h+2)*(*w+1));

	// vlastni cteni
	for(y = 0; y < *h+1; y++) {
		for( plane = 0; plane < 3; plane++)  { // precteni vsech tri barevnych hladin
			x = 0;
			while (x < m_header.BytesPerLine) {  // dekodovani jedne radky ze souboru
				file.Read(&b, sizeof(b));

		     if ((b & 0xC0) == 0xC0) {             /* Two-byte code    */
		        cnt = b & 0x3F;             /* Get run count    */
					file.Read(&b, sizeof(b));
		      }
		      else cnt = 1;                       /* Run count is one */

				for ( i = 0; i < cnt; i++ ) buf[plane][x++] = b;
			}
		}

		cr = buf[0]; // vlastni zapsani
		cg = buf[1];
		cb = buf[2];
		byte *b;
		b = &dataBuf[(*h-y)*(m_header.BytesPerLine)*3];
		for(x = 0; x < m_header.BytesPerLine; x++) {
			*b++ = *cb++;
			*b++ = *cg++;
			*b++ = *cr++;
		}
	}

	*w = m_header.BytesPerLine;
	*h = *h + 1;

	file.Close();

	return dataBuf;
}



